
import numpy as np
import matplotlib.pyplot as plt

qm_energies_before = np.loadtxt("qm_energies.dat")
mm_energies_before = np.loadtxt("gaff.dat")


seed = "/local/scratch/jm4g18/august2020/caffeine/adaptive_param_with_scaling_constants/scc_dftb/energies_forces/normal_reg/dftb_adaptive_parametrization/sampling_gaff_mod/"
qm_energies_after = np.loadtxt(seed + "qm_energies.dat")
mm_energies_after = np.loadtxt(seed + "after.dat")


rmse_gaff =  np.sqrt(np.mean((mm_energies_before - qm_energies_before - np.mean(mm_energies_before-qm_energies_before)) ** 2))
rmse_after =  np.sqrt(np.mean((mm_energies_after - qm_energies_after - np.mean(mm_energies_after-qm_energies_after)) ** 2))

print("RMSE_GAFF",rmse_gaff)
print("RMSE_AFTER",rmse_after)


import matplotlib.pyplot as plt
import seaborn as sns
sns.set(style="darkgrid")
from matplotlib import rc


x = y = np.arange(-1000,1000)
#sns.plot(x,y,  color="black")
sns.kdeplot(qm_energies_before-np.mean(qm_energies_before),mm_energies_before-np.mean(mm_energies_before), shade=True, shade_lowest=False, alpha=1, label="GAFF(RMSE={:.2f} kJ/mol)".format(rmse_gaff))
sns.kdeplot(qm_energies_after-np.mean(qm_energies_after),mm_energies_after-np.mean(mm_energies_after), shade=True, shade_lowest=False, alpha=0.6, label="GAFF.MOD (RMSE={:.2f} kJ/mol)".format(rmse_after))



plt.ylabel(r"$E^{MM}-\langle E^{MM} \rangle$ (kJ/mol)")
plt.xlabel(r"$E^{QM}-\langle E^{QM} \rangle$ (kJ/mol)")

plt.legend(loc="upper center")
plt.ylim((-60,60))
plt.xlim((-60,60))
plt.axes().set_aspect('equal')
plt.savefig("energy_distr.pdf", pad_inches=0, bbox_inches="tight")
plt.show()



