import pandas as pd
import matplotlib.pyplot as plt
import seaborn as sns
import numpy as np
import matplotlib.patches as mpatches
sns.set()

qm_energies_gaff = np.loadtxt("../gaff/qm_energies.dat").reshape(-1,1)[:,0]
qm_energies_after = np.loadtxt("../gaff_mod/qm_energies.dat").reshape(-1,1)[:,0]
mm_energies_before = np.loadtxt("../gaff/gaff.dat").reshape(-1,1)[:,0]
mm_energies_after = np.loadtxt("../gaff_mod/gaff.dat").reshape(-1,1)[:,0]


rmse_gaff =  np.sqrt(np.mean((mm_energies_before - qm_energies_gaff - np.mean(mm_energies_before-qm_energies_gaff)) ** 2))
rmse_after =  np.sqrt(np.mean((mm_energies_after - qm_energies_after - np.mean(mm_energies_after-qm_energies_after)) ** 2))

print("RMSE_GAFF",rmse_gaff)
print("RMSE_AFTER",rmse_after)


fig=plt.figure(figsize=(6,6))

import matplotlib.pyplot as plt
import seaborn as sns
alpha=0.6
sns.kdeplot(qm_energies_gaff-np.mean(qm_energies_gaff),mm_energies_before-np.mean(mm_energies_before), shade=True, shade_lowest=False, alpha=alpha,label="GAFF (RMSE={:.2f} kJ/mol)".format(rmse_gaff), color="blue")
sns.kdeplot(qm_energies_after-np.mean(qm_energies_after),mm_energies_after-np.mean(mm_energies_after), shade=True, shade_lowest=False, alpha=alpha, label="GAFF.MOD (RMSE={:.2f} kJ/mol)".format(rmse_after), color="green")

blue_patch = mpatches.Patch(color="#c4c4f4", label="GAFF (RMSE={:.2f} kJ/mol)".format(rmse_gaff))
green_patch = mpatches.Patch(color="#92e095", label="GAFF.MOD (RMSE={:.2f} kJ/mol)".format(rmse_after))
plt.legend(handles=[blue_patch, green_patch])
plt.xlim([-70,70])
plt.ylim([-70,70])
plt.xlabel(r"$E^{QM} - \langle E^{QM} \rangle$ (kJ/mol)")
plt.ylabel(r"$E^{MM} - \langle E^{MM} \rangle$ (kJ/mol)")
plt.show()
fig.savefig('caffeine_vv10_energies.pdf', bbox_inches="tight")



